<?php

class GoogleSearchController extends EvGoogleSearchAppController {

	public $components = array(
		'EvGoogleSearch.GoogleSearch'
	);

	public function beforeFilter() {
		parent::beforeFilter();

		$this->Auth->allow('search');
	}

	/**
	 * Performs the google custom search!
	 * @param  string $searchTerm the search term that the user has made
	 */
	public function search($searchTerm = null) {
		if (empty($searchTerm)) {
			if ($this->request->data('search_term') !== null) {
				// extract search term from post data and redirect back here
				$searchTerm = $this->request->data('search_term');
				$searchTerm = Inflector::slug($searchTerm, '+');

				$this->redirect(array(
					'controller' => 'google_search',
					'action' => 'search',
					$searchTerm
				));
			} else {
				// do nothing else - no search term
				$this->set('results', false);
			}

		} else {
			// grab the page number
			$pageNumber = $this->GoogleSearch->getPageNumber();

			// perform the search, see GoogleSearchComponent::search() for additional params
			$results = $this->GoogleSearch->search($searchTerm, $pageNumber);

			$this->set('results', $results);
			$this->set('searchTerm', $searchTerm);
			$this->set('pageNumber', $pageNumber);
		}

		$this->view = 'EvGoogleSearch.GoogleSearch/search';

		return;
	}
}
